HDU_1542 线段树离散化+扫描线 平面面积计算

也是很久之前的题目,一直没做

做完之后觉得基本的离散化和扫描线还是不难的,由于本题要离散x点的坐标,最后要计算被覆盖的x轴上的长度,所以不能用普通的建树法,建树建到r-l==1的时候就停止,表示某段而不是某点,同样,左子树和右子树要变成 L MID , MID R

比如1-4子树就是 1-2,2-4。。。2-4再分成2-3,3-4.

然后就是经典的扫描线用法,对下边设标记为1,上边设标记为-1,每次求得x轴被覆盖的长度,乘以和下一条线段的距离(即矩形的高)即可

#include <iostream>
#include <cstdio>
#include <cstring>
#include <algorithm>
#define lson rt<<1,l,mid
#define rson rt<<1|1,mid,r
using namespace std;
const int N = 210;
double d[N*N];
int flag[N*N];
int n;
double X[N];
struct node
{
    double l,r,y,f;
    bool operator < (const node &rhs) const{
        return y<rhs.y;
    }
}seg[N];
void build(int rt,int l,int r)
{
    flag[rt]=0;
    d[rt]=0;
    if (r-l<=1){
        return;
    }
    int mid=(l+r)>>1;
    build(lson);
    build(rson);
}
void up(int rt,int l,int r)
{
    if (flag[rt]>0){
        d[rt]=X[r]-X[l];
    }
    else
    {
        if (r-l==1) d[rt]=0;
        else d[rt]=d[rt<<1]+d[rt<<1|1];
    }
}
void cover(int L,int R,double v,int rt,int l,int r)
{
    //cout<<l<<" @@@ "<<r<<endl;
    if (L<=l && r<=R){
        flag[rt]+=v;
        up(rt,l,r);
        return;
    }
    if (r-l<=1) return;
    int mid=(l+r)>>1;
    if (R<=mid) cover(L,R,v,lson);
    else
    if (L>mid)  cover(L,R,v,rson);
    else
    {
        cover(L,R,v,lson);
        cover(L,R,v,rson);
    }
    up(rt,l,r);
}
int main()
{
    double xa,ya,xb,yb;
    int kase=0;
    while (scanf("%d",&n)!=EOF)
    {
        if (n==0) break;
        int cnt=1;
        for (int i=1;i<=n;i++){
            scanf("%lf%lf%lf%lf",&xa,&ya,&xb,&yb);
            X[cnt]=xa;
            seg[cnt++]=(node){xa,xb,ya,1.0};
            X[cnt]=xb;
            seg[cnt++]=(node){xa,xb,yb,-1.0};
        }
        sort(X+1,X+cnt);
        sort(seg+1,seg+cnt);
        int tmp=1;
        for (int i=2;i<cnt;i++){
            if(X[i]!=X[i-1]){
                X[++tmp]=X[i];
            }
        }
        build(1,1,tmp);
        double ans=0;
        for (int i=1;i<cnt-1;i++){
            //cout<<seg[i].l<<" .. "<<seg[i].r<<endl;
            int l1=lower_bound(X+1,X+1+tmp,seg[i].l)-X;
            int l2=lower_bound(X+1,X+1+tmp,seg[i].r)-X;
            //cout<<l1<<" "<<l2<<" "<<X[l1]<<" "<<X[l2]<<endl;
            cover(l1,l2,seg[i].f,1,1,tmp);
            //cout<<d[1]<<endl;
            ans+=d[1]*(seg[i+1].y-seg[i].y);
            //cout<<ans<<endl;
        }
        printf("Test case #%d\n",++kase);
        printf("Total explored area: %.2lf\n",ans);
        puts("");
    }
    return 0;
}

  

时间: 2024-10-10 08:40:57

HDU_1542 线段树离散化+扫描线 平面面积计算的相关文章

hdu1255--覆盖的面积(线段树+离散化+扫描线)

E - 覆盖的面积 Time Limit:5000MS     Memory Limit:32768KB     64bit IO Format:%I64d & %I64u Submit Status Description 给定平面上若干矩形,求出被这些矩形覆盖过至少两次的区域的面积. Input 输入数据的第一行是一个正整数T(1<=T<=100),代表测试数据的数量.每个测试数据的第一行是一个正整数N(1<=N<=1000),代表矩形的数量,然后是N行数据,每一行包含

hdu1828 Picture(线段树+离散化+扫描线)两种方法

C - Picture Time Limit:2000MS     Memory Limit:10000KB     64bit IO Format:%I64d & %I64u Submit Status Description A number of rectangular posters, photographs and other pictures of the same shape are pasted on a wall. Their sides are all vertical or

POJ 2482 Stars in Your Window 线段树+离散化+扫描线

题面据说很美- 每个星星可以根据在窗口的左下角和右上角两个位置建立两条扫描线,之后就是简单的区间增减和求最大值操作了. 注意要处理在边界上的星星是不算的情况,其实只要把左右边界分别增减一个eps即可. #include <cstdio> #include <cstring> #include <iostream> #include <map> #include <set> #include <vector> #include <

HDU 1542 Atlantis 线段树+离散化+扫描线

题意:给出一些矩形的最上角坐标和右下角坐标,求这些矩形的面积并. NotOnlySuccess 线段树专辑中扫描线模板题,弱智的我对着大大的代码看了一下午才搞懂. 具体见思路见注释=.= #include <cstdio> #include <cstring> #include <algorithm> #include <vector> #define lson rt<<1,l,mid #define rson rt<<1|1,mid

poj3277--City Horizon(线段树+离散化+扫描线)

City Horizon Time Limit: 2000MS   Memory Limit: 65536K Total Submissions: 16206   Accepted: 4414 Description Farmer John has taken his cows on a trip to the city! As the sun sets, the cows gaze at the city horizon and observe the beautiful silhouette

【POJ 2482】 Stars in Your Window(线段树+离散化+扫描线)

[POJ 2482] Stars in Your Window(线段树+离散化+扫描线) Time Limit: 1000MS   Memory Limit: 65536K Total Submissions: 11294   Accepted: 3091 Description Fleeting time does not blur my memory of you. Can it really be 4 years since I first saw you? I still remembe

HDU 3642 线段树+离散化+扫描线

题意:给你N个长方体的左下角和右上角坐标,问你空间中有多少体积是被大于两个不同的立方体覆盖的.x,y~10^6 z~500 考虑到给的z比较小,所以可以直接枚举z,然后跑二维的扫描线就好. 关于处理被不同的线段覆盖三次的问题,可以维护四个信息,cnt,once,twice,more,然后相互推出结果就好. #include <cstdio> #include <cstring> #include <vector> #include <algorithm> #

poj1151-- Atlantis(线段树+离散化+扫描线)

Atlantis Time Limit:1000MS     Memory Limit:10000KB     64bit IO Format:%I64d & %I64u Submit Status Description There are several ancient Greek texts that contain descriptions of the fabled island Atlantis. Some of these texts even include maps of pa

POJ 1177/HDU 1828 picture 线段树+离散化+扫描线 轮廓周长计算

求n个图矩形放下来,有的重合有些重合一部分有些没重合,求最后总的不规则图型的轮廓长度. 我的做法是对x进行一遍扫描线,再对y做一遍同样的扫描线,相加即可.因为最后的轮廓必定是由不重合的线段长度组成的,这样理论上是对的 要注意处理高度相同的线段,把底边优先处理(在代码里就是f标记为1的线段),因为若是一个矩形的底边和另一个矩形的上边重合,则这个轮廓肯定不能算 不过POJ和HDU的数据好像都比较弱,我没进行上面的细节处理也AC了,不过一个很简单的数据就会不对,所以还是要处理一下才是真正正确的代码 我